# fw_stochastic_rsi      2012 Feb 05 revised at 23:45 
 
 
 
# thinkorswim, inc. (c) 2008-2010
#
declare lower;
input RSI_length = 14;
input over_bought = 80;
input over_sold = 20;
 
input RSI_choice = {default "RSI Wilder", "RSI EMA"};
input RSI_price = close;
input KPeriod = 14;
input DPeriod = 3;
input slowing_period = 1;
input smoothingType = {Default SMA, EMA};
def RSI;
switch (rsi_choice) {
case "RSI EMA":
    RSI = RSI_EMA(price = RSI_price, length = RSI_length);
case "RSI Wilder":
    RSI = RSIWilder(price = RSI_price, length = RSI_length);
}
plot FullK = StochasticFull(over_bought, over_sold, KPeriod, DPeriod, RSI, RSI, RSI, slowing_period, smoothingType).FullK;
plot FullD = StochasticFull(over_bought, over_sold, KPeriod, DPeriod, RSI, RSI, RSI, slowing_period, smoothingType).FullD;
plot OverBought = over_bought;
plot OverSold = over_sold;
plot center = 50;
FullK.SetDefaultColor(GetColor(6));
FullD.SetDefaultColor(GetColor(5));
OverBought.SetDefaultColor(GetColor(1));
OverSold.SetDefaultColor(GetColor(1));
center.SetDefaultColor(GetColor(9));
AddCloud (FullK,center , color. green, color. red);

#########

plot upone = if (FullK > OverBought and FullK [1]<= OverBought [1]) then FullK [1] else double.NaN;
upone.SetPaintingStrategy(PaintingStrategy.ARROW_UP);
upone.setDefaultColor(color. blue);
upone.SetLineWeight(2);
 
plot downone = if (FullK < OverSold and FullK [1]>= OverSold [1]) then FullK [1] else double.NaN;
downone.SetPaintingStrategy(PaintingStrategy.ARROW_DOWN);
downone.setDefaultColor(color.magenta);
downone.SetLineWeight(2); 
 
####
 
 plot uptwo = if (FullK > OverSold and FullK [1]<= OverSold [1]) then FullK
[1] else double.NaN;
uptwo.SetPaintingStrategy(PaintingStrategy.ARROW_UP);
uptwo.setDefaultColor(color.green);
uptwo.SetLineWeight(2);
 
plot downtwo = if (FullK< OverBought and FullK [1]>= OverBought [1]) then FullK [1] else double.NaN;
downtwo.SetPaintingStrategy(PaintingStrategy.ARROW_DOWN);
downtwo.setDefaultColor(color.red);
downtwo.SetLineWeight(2);

 ###############
 
 plot up = if (FullK > center  and FullK [1]<= center [1]) then FullK [1] else double.NaN;
up.SetPaintingStrategy(PaintingStrategy.ARROW_UP);
up.setDefaultColor(color.cyan);;  
up.SetLineWeight(4);
 
plot down = if (FullK < center and FullK [1]>= center  [1]) then FullK [1] else double.NaN;
down.SetPaintingStrategy(PaintingStrategy.ARROW_DOWN);
down.setDefaultColor(color.yellow);
down.SetLineWeight(4);

#####
 
plot up1 = if (Fullk> Fulld  and Fullk [1]<= Fulld [1]) then Fullk [1] else double.NaN;
up1.SetPaintingStrategy(paintingstrategy.line_vs_squares );
up1.setDefaultColor(color.white); 
up1.SetLineWeight(4);
 
plot down1 = if (Fullk < Fulld and Fullk [1]>= Fulld  [1]) then Fullk [1] else double.NaN;
down1.SetPaintingStrategy(paintingstrategy.line_vs_squares );
down1.setDefaultColor(color.black);
down1.SetLineWeight(4);
#####

# END
